package com.oguerreiro.resilient.domain.enumeration;

import com.oguerreiro.resilient.domain.ResilientLog;

/**
 * <b>Resilient Log Level Enum</b> <br>
 * The level of the log associated with the log message {@link ResilientLog}
 * <ul>
 * <li>{@link #INFO}</li>
 * <li>{@link #WARN}</li>
 * <li>{@link #ERROR}</li>
 * </ul>
 * 
 */
public enum ResilientLogLevel {
  /**
   * Default, if no level defined. Use this just to log information about the ongoing process.
   */
  INFO,

  /**
   * Warning messages occurred within the process. Use this to tell users aspects of improvement, or suspicious things
   * that should be better evaluated.
   */
  WARN,

  /**
   * Errors. Definitely something the user MUST act. Use this to give better knowledge of the occurred error and, if
   * possible, the actions that the user should do.
   */
  ERROR,
}
