package com.oguerreiro.resilient.web.rest;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.oguerreiro.resilient.domain.UnitType;
import com.oguerreiro.resilient.repository.UnitTypeRepository;
import com.oguerreiro.resilient.service.UnitTypeService;
import com.oguerreiro.resilient.service.dto.UnitTypeDTO;
import com.oguerreiro.resilient.service.mapper.UnitTypeMapper;

/**
 * REST controller for managing {@link com.oguerreiro.resilient.domain.UnitType}.
 */
@RestController
@RequestMapping("/api/unit-types")
public class UnitTypeResource extends AbstractResilientResource<UnitType, UnitTypeDTO, Long> {

  private static final String ENTITY_NAME = "unitType";

  public UnitTypeResource(UnitTypeRepository unitTypeRepository, UnitTypeService unitTypeService,
      UnitTypeMapper unitTypeMapper) {
    super(UnitType.class, unitTypeRepository, unitTypeService);
  }

  /* Abstract methods impl*/
  @Override
  protected String getEntityName() {
    return ENTITY_NAME;
  }

}
