import { Component, input } from '@angular/core';
import { RouterModule } from '@angular/router';

import SharedModule from 'app/shared/shared.module';
import { DurationPipe, FormatMediumDatetimePipe, FormatMediumDatePipe } from 'app/shared/date';
import { IInputData, NewInputData } from '../input-data.model';
import { AbstractResilientEntityComponent } from 'app/entities/resilient/resilient-entity.component';
import { InputDataService } from '../service/input-data.service';

@Component({
  standalone: true,
  selector: 'jhi-input-data-detail',
  templateUrl: './input-data-detail.component.html',
  imports: [SharedModule, RouterModule, DurationPipe, FormatMediumDatetimePipe, FormatMediumDatePipe],
})
export class InputDataDetailComponent extends AbstractResilientEntityComponent<IInputData, NewInputData, InputDataService> {
  inputData = input<IInputData | null>(null);

  constructor(service: InputDataService) { super(service); }
  
  previousState(): void {
    window.history.back();
  }
}
