import { Routes } from '@angular/router';

import { UserRouteAccessService } from 'app/core/auth/user-route-access.service';
import { ASC } from 'app/config/navigation.constants';
import { InventoryComponent } from './list/inventory.component';
import { SecurityAction } from 'app/security/security-action.model';
import { InventoryService } from './service/inventory.service';
import { Resources } from 'app/security/resources.model';

const inventoryRoute: Routes = [
  {
    path: '',
    component: InventoryComponent,
    canActivate: [UserRouteAccessService],
    data: {
      authorities: ['ROLE_ADMIN', 'ROLE_MANAGER', 'ROLE_COORDINATOR', 'ROLE_USER'],
    }
  },
];

export default inventoryRoute;
