jest.mock('@ng-bootstrap/ng-bootstrap');

import { ComponentFixture, TestBed, inject, fakeAsync, tick } from '@angular/core/testing';
import { HttpResponse } from '@angular/common/http';
import { HttpClientTestingModule } from '@angular/common/http/testing';
import { of } from 'rxjs';
import { NgbActiveModal } from '@ng-bootstrap/ng-bootstrap';

import { VariableClassTypeService } from '../service/variable-class-type.service';

import { VariableClassTypeDeleteDialogComponent } from './variable-class-type-delete-dialog.component';

describe('VariableClassType Management Delete Component', () => {
  let comp: VariableClassTypeDeleteDialogComponent;
  let fixture: ComponentFixture<VariableClassTypeDeleteDialogComponent>;
  let service: VariableClassTypeService;
  let mockActiveModal: NgbActiveModal;

  beforeEach(() => {
    TestBed.configureTestingModule({
      imports: [HttpClientTestingModule, VariableClassTypeDeleteDialogComponent],
      providers: [NgbActiveModal],
    })
      .overrideTemplate(VariableClassTypeDeleteDialogComponent, '')
      .compileComponents();
    fixture = TestBed.createComponent(VariableClassTypeDeleteDialogComponent);
    comp = fixture.componentInstance;
    service = TestBed.inject(VariableClassTypeService);
    mockActiveModal = TestBed.inject(NgbActiveModal);
  });

  describe('confirmDelete', () => {
    it('Should call delete service on confirmDelete', inject(
      [],
      fakeAsync(() => {
        // GIVEN
        jest.spyOn(service, 'delete').mockReturnValue(of(new HttpResponse({ body: {} })));

        // WHEN
        comp.confirmDelete(123);
        tick();

        // THEN
        expect(service.delete).toHaveBeenCalledWith(123);
        expect(mockActiveModal.close).toHaveBeenCalledWith('deleted');
      }),
    ));

    it('Should not call delete service on clear', () => {
      // GIVEN
      jest.spyOn(service, 'delete');

      // WHEN
      comp.cancel();

      // THEN
      expect(service.delete).not.toHaveBeenCalled();
      expect(mockActiveModal.close).not.toHaveBeenCalled();
      expect(mockActiveModal.dismiss).toHaveBeenCalled();
    });
  });
});
